
;#######################
; Images & numero (number)
; UI : 0 = canvas ;  2 = previewbrush, 3 = fond canvas, 4 = , 
; BRUSH : 1 = brush, 5 =pbrush, 7 = copy brush (pour rotation, 13 = copy brush
; 
; 100 = layer d'origine (N1)
;
;#######################

;note : 

; le canvas = motif (checker) + les calques. On dessine donc sur le canvas les images dans l'ordre : 0. motif, 1. layer en position 1, 2.layer en position 2, etc...
; le layer sur lequel on peint = current_layer
; l'image qu'on sauvegarde (#IMAGE_LoadSave) = les layers uniquement (sans le motif-checker)
; le calque qu'on sauvegarde = current_layer


;{ Motif & canvas 
; Motif = pattern checker For the canvas
; on load le motif de base (un checker)
If LoadImage(#Motif_canvas,"paper\paper"+Str(bgcavansId)+".png")
  repetx =Round(canvas_w/ImageWidth(#motif_canvas),1)
  repety =Round(canvas_h/ImageHeight(#motif_canvas),1)
Else
  MessageRequester("Erreur","Impossible de charger le paper, un paper par defaut est cre",#MB_ICONERROR); error, can't load the image of the canvas.
  CreateImage(#motif_canvas,64,64)
  StartDrawing(ImageOutput(#motif_canvas))
  Box(0,0,64,64,RGB(125,125,125))
  StopDrawing()
EndIf

; While 
;   wend

; puis on cre l"image pour ce motif, on mettra ce motif en fond de canvas
CreateImage(#canvasBG,doc_w,doc_h)
If IsImage(#canvasBG)
  If StartDrawing(ImageOutput(#canvasBG))
    For i=0 To repetx 
      For j = 0 To repety
        DrawImage(ImageID(#motif_canvas),i*64,j*64)
      Next j  
    Next i
    StopDrawing()
  Else
    MessageRequester("Erreur","Impossible de dessiner sur l'image (canvas)",#MB_ICONERROR); error, can't draw on the canvas
  EndIf  
Else    
  MessageRequester("Erreur","Impossible de crer l'image (canvas)",#MB_ICONERROR); error, can't create the image.
EndIf

If CreateImage(#Canvas_Final,doc_w,doc_h,32)
EndIf


;}

;{ layer de base : image sur laquelle on peint / base layer, image on which we paint
If CreateImage(#layer_base+1,doc_w,doc_h,32)
  If StartDrawing(ImageOutput(#layer_base+1))
  DrawingMode(#PB_2DDrawing_AlphaChannel)
    Box(0,0,doc_w,doc_h,RGBA(255,255,255,0))
    StopDrawing()
  Else
    MessageRequester("Erreur","Impossible de dessiner sur l'image (layer)",#MB_ICONERROR); can't draw on the layer
  EndIf
Else
  MessageRequester("Erreur","Impossible de crer l'image (layer)",#MB_ICONERROR); can't create the image
EndIf
;}

;{ layer (menu)
; layer background (= center normal ?)

; menu : image du bouton layer 
; CreateImage(#Img_Pan_layerVue,25,25) ; visible
; StartDrawing(ImageOutput(#Img_Pan_layerVue))
; Box(0,0,30,30,RGB(200,200,200))
; StopDrawing()

; Icone des layers
ImageLoad2(#Img_Pan_FondLayer,"ui\layer.jpg",254,25)  
ImageLoad2(#Img_Pan_layerVue,"ui\layereye.jpg",11,9)  
ImageLoad2(#Img_Pan_LayerLock,"ui\layerlocked.jpg")  
ImageLoad2(#Img_Pan_FondLayerSel,"ui\layersel.jpg",254,25)  

; bouton du panel layers
ImageLoad2(#Img_btn_newlayer,"ui\layerbtn1.jpg")
ImageLoad2(#Img_btn_suplayer,"ui\layerbtn2.jpg")
ImageLoad2(#Img_btn_masklayer,"ui\layerbtn3.jpg")
ImageLoad2(#Img_btn_reglayer,"ui\layerbtn4.jpg")



CreateImage(#Img_Pan_LayerCenter,350,25) ; center normal
StartDrawing(ImageOutput(#Img_Pan_LayerCenter))
DrawImage(ImageID(#Img_Pan_FondLayer),0,0)
DrawImage(ImageID(#Img_Pan_layerVue),5,10)
StopDrawing()

CreateImage(#Img_Pan_LayerCenterSel,350,25) ; center selected
StartDrawing(ImageOutput(#Img_Pan_LayerCenterSel))
DrawImage(ImageID(#Img_Pan_FondLayerSel),0,0)
DrawImage(ImageID(#Img_Pan_layerVue),5,10)
StopDrawing()
;}

;{ swatch & RoughBoard
;bordure
CreateImage(#Img_swatch,200,200)
StartDrawing(ImageOutput(#Img_swatch))
Box(0,0,200,200,RGB(255,255,255))
For i = 0 To 20
  Line(0,i*12,200,1,RGB(120,120,120))
Next i
For i = 0 To 20
  Line(i*12,0,1,200,0)
Next i
StopDrawing()

; roughBoard
LoadImage(#Img_roughboard,"swatches\rb.png")
If IsImage(#Img_roughboard) = 0
  MessageRequester("Erreur","Le fichier rb.png ne semble pas prsent dans le dossier Swatches."+Chr(13)+"Une roughboard avec une superbe couleur Rose est donc cre :).") 
  CreateImage(#Img_roughboard, 140,250)
  StartDrawing(ImageOutput(#Img_roughboard))
  Box(0,0,ImageWidth(#Img_roughboard),ImageHeight(#Img_roughboard),RGB(230,157,248))
  StopDrawing()
EndIf

;}

;{ brush
If LoadImage(#brush,brush_dir$+"\brush"+Str(brushId)+".png")
  If IsImage(#brush)
    If ResizeImage(#brush,preview_size,preview_size,#PB_Image_Smooth)
    Else
      MessageRequester("Erreur","Impossible de Redimensionner l'image (Brush)",#MB_ICONERROR); can't resize the brush
    EndIf
  Else
    MessageRequester("Erreur","l'image (Brush) n'existe pas",#MB_ICONERROR); the brush doesn't exist
  EndIf  
Else
  MessageRequester("Erreur","Impossible d'ouvrir l'image (brush)",#MB_ICONERROR); can't open the image (brush)
EndIf

; copy brush needed !
If CreateImage(#pbrush,32,32,32); brush_copy avec lequel on peint - a brush copy to paint with
  If CopyImage(#brush,#brushcopy) = 0 Or CopyImage(#brush, #brushcopy2) = 0 ;two copy needed (size and rotation.
    MessageRequester("Erreur","Impossible de copier l'image (brush_copy)",#MB_ICONERROR); can't copy the brush
  EndIf  
Else
  MessageRequester("Erreur","Impossible de crer l'image (brush_copy)",#MB_ICONERROR); can't create the image
EndIf
;}

;{ preview Brush & Color
If CreateImage(#previewbrush1,preview_size,preview_size,32)
  
  ; preview brush
  If StartDrawing(ImageOutput(#previewbrush1))
    DrawingMode(#PB_2DDrawing_AlphaChannel)
    Box(0,0,preview_size,preview_size,RGBA(15,15,15,255))
    DrawingMode(#PB_2DDrawing_Default)
    Box(0,0,preview_size,preview_size,RGBA(125,125,125,0))
    DrawingMode(#PB_2DDrawing_AlphaBlend)    
    DrawImage(ImageID(#brush),0,0)
    StopDrawing()
    
    ; preview color selector
    If CreateImage(#previewcoloBG,30,30) ; color fg
      If CreateImage(#previewcoloFG,30,30); color bg  
      Else
        MessageRequester("Erreur","Impossible de crer l'image (preview color FG)",#MB_ICONERROR); can't create the image
      EndIf  
    Else
      MessageRequester("Erreur","Impossible de crer l'image (preview color BG)",#MB_ICONERROR); can't create the image
    EndIf
    
    ; color select Front Ground color  (color_fg)   
    If StartDrawing(ImageOutput(#previewcoloBG))
      Box(0,0,30,30,RGB(255,255,255))
      Box(1,1,28,28,color)
      StopDrawing()
    Else
      MessageRequester("Erreur","Impossible de dessiner sur l'image (Color BG preview)",#MB_ICONERROR); can't draw on the image
    EndIf
    
    ; color select BackGround color (color_bg)
    If  StartDrawing(ImageOutput(#previewcoloFG))
      Box(0,0,30,30,RGB(255,255,255))
      Box(1,1,28,28,color_BG)
      StopDrawing()
    Else
      MessageRequester("Erreur","Impossible de dessiner sur l'image (Color FG preview)",#MB_ICONERROR); can't draw on the image
    EndIf
  Else
    MessageRequester("Erreur","Impossible de dessiner sur l'image (brush preview)",#MB_ICONERROR); can't draw on the image
  EndIf  
Else
  MessageRequester("Erreur","Impossible de crer l'image (brush preview)",#MB_ICONERROR) ;can't create the image
EndIf

;}


; IDE Options = PureBasic 4.60 Beta 3 (Windows - x86)
; CursorPosition = 4
; Folding = A-
; EnableXP